//+------------------------------------------------------------------+
//|                                                           EA.mq4 |
//|                                                               Me |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Me"
#property link      ""
#import "stdlib.ex4"
   string ErrorDescription(int a0);
#import "kernel32.dll"

  void OutputDebugStringA(string msg); //used in log()
#import
//--- input parameters
extern bool      SendLogToDebugView=true;
extern int       SecBetwSendingLog=5;
extern double    LotSize=0.1;
extern double    StopLoss=150.0;
extern double    TakeProfit=20.0;
extern double    TakeProfit_1=10;
extern double    TakeProfit_2=15;
extern double    TakeProfit_3=30;
extern int       iMaxOrders=3;
extern int       Slippage=5;
extern int       MagicNumber=814;
extern double Value_Diff= 0.0003;
extern int    Fast_MA_Value=20;
extern int    Slow_MA_Value=10;

extern double    TrailingStart=7.0;
extern double    TrailingStop=1.0;
extern double    TrailingStart_2=5.0;
extern double    TrailingStop_2=1.0;
extern double    TrailingStep=1.0;

extern int       iOrderType_Buy=0;
extern int       iOrderType_Sell=1;
extern bool      bWriteToDebugView=true;
extern bool      bShowDebugOnChart=true;

int BuyOrder_1,BuyOrder_2, BuyOrder_3 ;
int SellOrder;

int iOpenOrders_Sell;
int iOpenOrders_Buy;

int iLastError;


double dPip;
double dStopLossPrice, dTakeProfitPrice;

string sNL = " \n"; //new line
string sLogComment; //used for debugging using DebugView

string sLog_Start;
string sLog_CheckBuyConditions;
string sLog_CheckSellConditions;
string sLog_TrailOrder;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{

if(Digits == 2 || Digits == 3){
	dPip = 0.01;
}else{
if(Digits == 4 || Digits == 5)
	dPip = 0.0001;
}

return(0);

}

int deinit()
{

Comment("");
return(0);

}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+



int start()
{
sLog_Start = "START - start() function----------------------------------";

double Fast_EMA, Slow_SMA, MA_Difference_1, MA_Difference_2;
bool bOrderClosed;

//count open buy orders.
iOpenOrders_Buy = CntOrd(iOrderType_Buy,MagicNumber,Symbol());

//count open sell orders.
iOpenOrders_Sell = CntOrd(iOrderType_Sell,MagicNumber,Symbol());

if (iOpenOrders_Buy==3 || iOpenOrders_Sell==3)
{
if(TrailingStop>0 && TrailingStart > 0) TrailOrder (TrailingStart, TrailingStop); 
}

if (iOpenOrders_Buy==1 || iOpenOrders_Sell==1)
{
if(TrailingStop_2>0 && TrailingStart_2 > 0) TrailOrder_3 (TrailingStart_2, TrailingStop_2); 
}

sLog_Start = sLog_Start + sNL + "Setting Trailing Stops for Third Trade";

//count open buy orders.
iOpenOrders_Buy = CntOrd(iOrderType_Buy,MagicNumber,Symbol());

//count open sell orders.
iOpenOrders_Sell = CntOrd(iOrderType_Sell,MagicNumber,Symbol());

sLog_Start = sLog_Start + sNL + "    Start - Set and Get MA values";

Fast_EMA = iMA(NULL,0,Fast_MA_Value,0,MODE_EMA,PRICE_CLOSE,0);

Slow_SMA = iMA(NULL,0,Slow_MA_Value,0,MODE_SMA,PRICE_CLOSE,0);

MA_Difference_1= Fast_EMA-Slow_SMA;

MA_Difference_2= Slow_SMA-Fast_EMA;

sLog_Start = sLog_Start + sNL + "    Allowed MAX Orders =" +iMaxOrders;
sLog_Start = sLog_Start + sNL + "    Preferred Difference =" +Value_Diff;
sLog_Start = sLog_Start + sNL + "    Fast EMA's Value=" +  Fast_EMA;
sLog_Start = sLog_Start + sNL + "    Slow_SMA's Value=" +  Slow_SMA;
sLog_Start = sLog_Start + sNL + "    --------------------------------------------------";
sLog_Start = sLog_Start + sNL + "    VALUE DIFFERENCE:1=" +  MA_Difference_1;
sLog_Start = sLog_Start + sNL + "    --------------------------------------------------";
sLog_Start = sLog_Start + sNL + "    VALUE DIFFERENCE:2=" +  MA_Difference_2;
sLog_Start = sLog_Start + sNL + "    --------------------------------------------------";
sLog_Start = sLog_Start + sNL + "    Open Buy Orders=" +  iOpenOrders_Buy;
sLog_Start = sLog_Start + sNL + "    Open Sell Orders=" +  iOpenOrders_Sell;

if (MA_Difference_1>Value_Diff)
{
sLog_Start = sLog_Start + sNL + "    EA Should BUY Now" ;
}
if (MA_Difference_2>Value_Diff)
{
sLog_Start = sLog_Start + sNL + "    EA Should SELL Now" ;
}
sLog_Start = sLog_Start + sNL + "    End - Set and Get MA values";
sLog_Start = sLog_Start + sNL + "    --------------------------------------------------";

sLog_CheckBuyConditions =  "    Start - Checking Buy condition----";

///////////////////////////// Checking Buying Condition

if (Fast_EMA>Slow_SMA)
{
if (MA_Difference_1>=Value_Diff && iOpenOrders_Buy ==0)
{

sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Buy condition is met. Check order count----";
	
//Start - Close open sell positions------------------------------------------
//check if there are open sell positions.
	if(iOpenOrders_Sell > 0) {

	bOrderClosed = closeSellOrder(iOrderType_Sell); //Closing Sell order
	
		if(bOrderClosed){
			sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Sell Order Closed";
		
		}else{ //order was not closed.
			iLastError = GetLastError();
			sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Closing Sell Order failed. Error code = " + ErrorDescription(iLastError);
		}
	}//end if(iOpenOrders_Sell > 0) {
//End - Close open sell positions------------------------------------------
		
		double OpenPrice=Ask;
		int count=3;

		double  dTakeProfitPrice_1,dTakeProfitPrice_2,dTakeProfitPrice_3;
		dStopLossPrice = NormalizeDouble(OpenPrice - StopLoss * dPip,Digits);
	
		dTakeProfitPrice_1 = NormalizeDouble(OpenPrice + TakeProfit_1 * dPip,Digits);
		dTakeProfitPrice_2 = NormalizeDouble(OpenPrice + TakeProfit_2 * dPip,Digits);
		dTakeProfitPrice_3 = NormalizeDouble(OpenPrice + TakeProfit_3 * dPip,Digits);
		
iLastError = 0;
   if (count==3) 
    {
    BuyOrder_1=OrderSend(Symbol(), iOrderType_Buy, LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_1, "Buy Order",MagicNumber, 0,Blue);
    if (BuyOrder_1>0) //Checking if the order was opened or not
      { 
      sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Buy order 1 sent successfully. Ticket=" + BuyOrder_1;
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();                               
          sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Error sending buy order 1. Error code=" + ErrorDescription(iLastError);

} 

}

  if (count==2) 
    {
    BuyOrder_2=OrderSend(Symbol(), iOrderType_Buy, LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_2, "Buy Order",MagicNumber, 0,Blue);
    if (BuyOrder_2>0) 
      { 
      sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Buy order 2 sent successfully. Ticket=" + BuyOrder_2;
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();
          sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Error sending buy order 2. Error code=" + ErrorDescription(iLastError);
} 

}

if (count==1) 
    {
    BuyOrder_3=OrderSend(Symbol(), iOrderType_Buy, LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_3, "Buy Order",MagicNumber, 0,Blue);
    if (BuyOrder_3>0) 
      {
      sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Buy order 2 sent successfully. Ticket=" + BuyOrder_3;
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();                               
          sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Error sending buy order 2. Error code=" + ErrorDescription(iLastError);


}  

}
 
// New  part	


sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    End - Checking Buy condition----";
sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    --------------------------------";
}
}
///////////////////////////// Checking Selling Condition
sLog_CheckSellConditions = "    Start - Checking Sell condition----";

if (Fast_EMA<Slow_SMA)
{
if (MA_Difference_2>=Value_Diff && iOpenOrders_Sell ==0)
{
sLog_CheckSellConditions = sLog_CheckSellConditions + sNL + "    Sell condition is met. Check order count----";

if(iOpenOrders_Buy > 0) {
		
		bOrderClosed = closeBuyOrder(iOrderType_Buy); //Closing Buy order
	
		if(bOrderClosed){
			sLog_CheckSellConditions = sLog_CheckSellConditions + sNL + "    Buy order is Closed";
		}else{
			iLastError = GetLastError();
			sLog_CheckSellConditions = sLog_CheckSellConditions + sNL + "    Closing Buy Order failed. Error code = " + ErrorDescription(iLastError);
		
		}//end else if(bOrderClosed){
	}//end if(iOpenOrders_Buy > 0) {
	
	
		OpenPrice=Bid;
		count=3;
		
      double SellOrder_1,SellOrder_2,SellOrder_3;
		dStopLossPrice = NormalizeDouble(OpenPrice + StopLoss * dPip,Digits);
		
		dTakeProfitPrice_1 = NormalizeDouble(OpenPrice - TakeProfit_1 * dPip,Digits);
		dTakeProfitPrice_2 = NormalizeDouble(OpenPrice - TakeProfit_2 * dPip,Digits);
		dTakeProfitPrice_3 = NormalizeDouble(OpenPrice - TakeProfit_3 * dPip,Digits);
		
iLastError = 0;
   if (count==3) 
    {
  SellOrder_1=OrderSend(Symbol() , iOrderType_Sell , LotSize,OpenPrice,Slippage ,dStopLossPrice ,dTakeProfitPrice_1 , "Sell Order",MagicNumber , 0,Red);
		
    if (SellOrder_1>0) //Checking if the order was opened or not
      { 
      sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Sell order 1 sent successfully. Ticket=" + SellOrder_1;
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();                               
          sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Error sending sell order 1. Error code=" + ErrorDescription(iLastError);

} 

}

  if (count==2) 
   {
  SellOrder_2=OrderSend(Symbol() , iOrderType_Sell , LotSize,OpenPrice,Slippage ,dStopLossPrice ,dTakeProfitPrice_2 , "Sell Order",MagicNumber , 0,Red);
		
    if (SellOrder_1>0) //Checking if the order was opened or not
      { 
      sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Sell order 2 sent successfully. Ticket=" + SellOrder_2;
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();                               
          sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Error sending sell order 1. Error code=" + ErrorDescription(iLastError);

} 

}

if (count==1) 
   {
  SellOrder_3=OrderSend(Symbol() , iOrderType_Sell , LotSize,OpenPrice,Slippage ,dStopLossPrice,dTakeProfitPrice_3 , "Sell Order",MagicNumber , 0,Red);
		
    if (SellOrder_3>0) //Checking if the order was opened or not
      { 
      sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Sell order 3 sent successfully. Ticket=" + SellOrder_3;
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();                               
          sLog_CheckBuyConditions = sLog_CheckBuyConditions + sNL + "    Error sending sell order 1. Error code=" + ErrorDescription(iLastError);

} 

}

 
// New  part		
	

sLog_CheckSellConditions  = sLog_CheckSellConditions + sNL + "END - Checking Sell condition----";
sLogComment = sLogComment + sNL + "END - start() function--------------------------------";
}
}

//send debug data to DebugView
if (bWriteToDebugView) {
	
	sLogComment = sLog_Start;
	sLogComment = sLogComment + sNL + sLog_TrailOrder;
	sLogComment = sLogComment + sNL + sLog_CheckBuyConditions;
	sLogComment = sLogComment + sNL + sLog_CheckSellConditions;
	
	log(sLogComment);
	
	Sleep(SecBetwSendingLog * 1000);
		
}//end if bWriteToDebugView {

//show debug data as comment
if (bShowDebugOnChart) { 
	Comment(sLogComment);
	
}//end if (bShowDebugOnChart) { 


return (0);

}

//////////////////////////////////////////////////////////////////// comparison

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void log(
   string s1,
   string s2 = "",
   string s3 = "",
   string s4 = "",
   string s5 = "",
   string s6 = "",
   string s7 = "",
   string s8 = ""
) 
{

  string out = StringTrimRight(StringConcatenate(
                                   WindowExpertName(), ".mq4 ", Symbol(),
                                   " ", s1,
                                   " ", s2,
                                   " ", s3,
                                   " ", s4,
                                   " ", s5,
                                   " ", s6,
                                   " ", s7,
                                   " ", s8
                                ));
   OutputDebugStringA(out);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CntOrd(int Type, int Magic, string Symb) {
//return number of orders matching the order type and symbol specific parameters. Magic number param is optional
int _CntOrd;
_CntOrd=0;
int iTotalOrders_;
iTotalOrders_ = OrdersTotal();

for(int i=iTotalOrders_;i>=0;i--)
{
   if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
 // Print("i=",i,"Symbol ", OrderSymbol(), " Order type= ", OrderType(), "Magic =", OrderMagicNumber()," ", Magic);
  
  
   if (OrderSymbol()==Symb) {
      if ( (OrderType()==Type && (OrderMagicNumber()==Magic) || Magic==0)) _CntOrd++;
         }
}
return(_CntOrd);
}//end int CntOrd(int Type, int Magic, string Symb) {
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

string boolToString(bool BoolVar){

string sBoolString;

if(BoolVar==FALSE){
   sBoolString = "FALSE";
}else{
   sBoolString = "TRUE";
}

return(sBoolString);

}//end string boolToString(bool BoolVar)
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void TrailOrder(double Trailingstart,double Trailingstop){
int ticket = 0;

sLog_TrailOrder = "    Start - TrailOrder function--------------------";

double tStopLoss;

//tStopLoss = NormalizeDouble(OrderStopLoss(), Digits); // Stop Loss. OrderSelect has to be run first before assinging a value to tStopLoss

int cnt;
double vPoint,vSlippage;

//double sl     = OrderStopLoss(); // Stop Loss. OrderSelect has to be run first before assinging a value to sl
double sl;


if (Digits == 3 || Digits == 5)
    {vPoint = Point * 10; vSlippage = Slippage * 10;    }
    else
    {vPoint = Point; vSlippage = Slippage;}

RefreshRates();

//
	for(cnt=0;cnt<2;cnt++){
	
	if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) continue;
	if(OrderSymbol() == Symbol() && OrderMagicNumber() ==  MagicNumber){
		
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    Order selected. OrderTicket=" + OrderTicket();
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderOpenPrice=" + DoubleToStr(OrderOpenPrice(),Digits);
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderStopLoss=" + DoubleToStr(OrderStopLoss(),Digits);
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderTakeProfit=" + DoubleToStr(OrderTakeProfit(),Digits);
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    ------------------------------";
	
		sl     = OrderStopLoss(); // Stop Loss. 
		tStopLoss = NormalizeDouble(OrderStopLoss(), Digits); // Stop Loss. 
		
		if(OrderType()==OP_BUY){
		
			if(Ask> NormalizeDouble(OrderOpenPrice()+TrailingStart* vPoint,Digits)
			&& tStopLoss < NormalizeDouble(Bid-(TrailingStop+TrailingStep)*vPoint,Digits)){
			
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    Ask=" + DoubleToStr(Ask,Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderOpenPrice=" + DoubleToStr(OrderOpenPrice(),Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    TrailingStart=" + TrailingStart;
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    vPoint=" + DoubleToStr(vPoint,6);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    TrailingStop=" + TrailingStop;
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    TrailingStep=" + DoubleToStr(TrailingStep,Digits);
			
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    Min Price=" + DoubleToStr(NormalizeDouble(OrderOpenPrice()+TrailingStart* vPoint,Digits),Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    tStopLoss=" + DoubleToStr(tStopLoss,Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    Min target SL=" + DoubleToStr(NormalizeDouble(Bid-(TrailingStop+TrailingStep)*vPoint,Digits),Digits);
			
				tStopLoss = NormalizeDouble(Bid-TrailingStop*vPoint,Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    new tStopLoss=" + DoubleToStr(tStopLoss,Digits);
				
				ticket = OrderModify(OrderTicket(),OrderOpenPrice(),tStopLoss,OrderTakeProfit(),0,Blue);

				if (ticket > 0){
					Print ("TrailingStop #2 Activated: ", OrderSymbol(), ": SL", tStopLoss, ": Bid", Bid);
					sLog_TrailOrder = sLog_TrailOrder + sNL + "    ticket " + ticket + " modified. New StopLoss=" + DoubleToStr(tStopLoss,Digits);
					
					}
					else{
					iLastError = GetLastError();
					
					sLog_TrailOrder = sLog_TrailOrder + sNL +  "    Error modifying stop loss. Error code=" + ErrorDescription(iLastError);
					//return(0);
					}
			}//end if(Ask> NormalizeDouble(OrderOpenPrice()+TrailingStart* vPoint,Digits) && tStopLoss < NormalizeDouble(Bid-(TrailingStop+TrailingStep)*vPoint,Digits)){
		}//end if(OrderType()==OP_BUY){

		if (OrderType()==OP_SELL) {
			if (Bid < NormalizeDouble(OrderOpenPrice()-TrailingStart*vPoint,Digits)
			&& (sl >(NormalizeDouble(Ask+(TrailingStop+TrailingStep)*vPoint,Digits)))
			|| (OrderStopLoss()==0)){
			
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    Bid=" + DoubleToStr(Bid,Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    Max Price=" + DoubleToStr(NormalizeDouble(OrderOpenPrice()-TrailingStart* vPoint,Digits),Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    sl=" + DoubleToStr(sl,Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    Min target SL=" + DoubleToStr(NormalizeDouble(Ask+(TrailingStop+TrailingStep)*vPoint,Digits),Digits);
				
				sl = NormalizeDouble(Ask+TrailingStop*vPoint,Digits);
								
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    new sl=" + DoubleToStr(sl,Digits);
				
				ticket = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Red);
				
				if (ticket > 0){
					Print ("Trailing #2 Activated: ", OrderSymbol(), ": SL ",sl, ": Ask ", Ask);
					sLog_TrailOrder = sLog_TrailOrder + sNL + "    ticket " + ticket + " modified. New StopLoss=" + DoubleToStr(sl,Digits);
					
					}
					else{
					iLastError = GetLastError();
					
					sLog_TrailOrder = sLog_TrailOrder + sNL +  "    Error modifying stop loss. Error code=" + ErrorDescription(iLastError);
					//return(0);
					}
				}
			}


}//end for(cnt=OrdersTotal();cnt>=0;cnt--){
}//end if(OrdersTotal()>0){
////// if if(OrderSymbol() == Symbol() && OrderMagicNumber() ==  MagicNumber)

sLog_TrailOrder = sLog_TrailOrder + sNL + "    End - TrailOrder function--------------------";

return(0);
}//end void TrailOrder(double Trailingstart,double Trailingstop){


//========================================================================================
void TrailOrder_3(double Trailingstart_2,double Trailingstop_2){
int ticket = 0;

sLog_TrailOrder = "    Start - TrailOrder function--------------------";

double tStopLoss;

//tStopLoss = NormalizeDouble(OrderStopLoss(), Digits); // Stop Loss. OrderSelect has to be run first before assinging a value to tStopLoss

int cnt;
double vPoint,vSlippage;

//double sl     = OrderStopLoss(); // Stop Loss. OrderSelect has to be run first before assinging a value to sl
double sl;


if (Digits == 3 || Digits == 5)
    {vPoint = Point * 10; vSlippage = Slippage * 10;    }
    else
    {vPoint = Point; vSlippage = Slippage;}

RefreshRates();

//
	
	if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)==TRUE){
	if(OrderSymbol() == Symbol() && OrderMagicNumber() ==  MagicNumber){
		
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    Order selected. OrderTicket=" + OrderTicket();
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderOpenPrice=" + DoubleToStr(OrderOpenPrice(),Digits);
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderStopLoss=" + DoubleToStr(OrderStopLoss(),Digits);
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderTakeProfit=" + DoubleToStr(OrderTakeProfit(),Digits);
		sLog_TrailOrder = sLog_TrailOrder + sNL + "    ------------------------------";
	
		sl     = OrderStopLoss(); // Stop Loss. 
		tStopLoss = NormalizeDouble(OrderStopLoss(), Digits); // Stop Loss. 
		
		if(OrderType()==OP_BUY){
		
			if(Ask> NormalizeDouble(OrderOpenPrice()+TrailingStart_2* vPoint,Digits)
			&& tStopLoss < NormalizeDouble(Bid-(TrailingStop_2+TrailingStep)*vPoint,Digits)){
			
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    Ask=" + DoubleToStr(Ask,Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    OrderOpenPrice=" + DoubleToStr(OrderOpenPrice(),Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    TrailingStart=" + TrailingStart_2;
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    vPoint=" + DoubleToStr(vPoint,6);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    TrailingStop=" + TrailingStop_2;
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    TrailingStep=" + DoubleToStr(TrailingStep,Digits);
			
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    Min Price=" + DoubleToStr(NormalizeDouble(OrderOpenPrice()+TrailingStart_2* vPoint,Digits),Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    tStopLoss=" + DoubleToStr(tStopLoss,Digits);
			sLog_TrailOrder = sLog_TrailOrder + sNL + "    Min target SL=" + DoubleToStr(NormalizeDouble(Bid-(TrailingStop_2+TrailingStep)*vPoint,Digits),Digits);
			
				tStopLoss = NormalizeDouble(OrderOpenPrice()+TrailingStop_2*vPoint,Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    new tStopLoss=" + DoubleToStr(tStopLoss,Digits);
				
				ticket = OrderModify(OrderTicket(),OrderOpenPrice(),tStopLoss,OrderTakeProfit(),0,Blue);

				if (ticket > 0){
					Print ("TrailingStop #2 Activated: ", OrderSymbol(), ": SL", tStopLoss, ": Bid", Bid);
					sLog_TrailOrder = sLog_TrailOrder + sNL + "    ticket " + ticket + " modified. New StopLoss=" + DoubleToStr(tStopLoss,Digits);
					
					}
					else{
					iLastError = GetLastError();
					
					sLog_TrailOrder = sLog_TrailOrder + sNL +  "    Error modifying stop loss. Error code=" + ErrorDescription(iLastError);
					//return(0);
					}
			}//end if(Ask> NormalizeDouble(OrderOpenPrice()+TrailingStart* vPoint,Digits) && tStopLoss < NormalizeDouble(Bid-(TrailingStop+TrailingStep)*vPoint,Digits)){
		}//end if(OrderType()==OP_BUY){

		if (OrderType()==OP_SELL) {
			if (Bid < NormalizeDouble(OrderOpenPrice()-TrailingStart_2*vPoint,Digits)
			&& (sl >(NormalizeDouble(Ask+(TrailingStop_2+TrailingStep)*vPoint,Digits)))
			|| (OrderStopLoss()==0)){
			
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    Bid=" + DoubleToStr(Bid,Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    Max Price=" + DoubleToStr(NormalizeDouble(OrderOpenPrice()-TrailingStart_2* vPoint,Digits),Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    sl=" + DoubleToStr(sl,Digits);
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    Min target SL=" + DoubleToStr(NormalizeDouble(Ask+(TrailingStop_2+TrailingStep)*vPoint,Digits),Digits);
				
				sl = NormalizeDouble(OrderOpenPrice()-TrailingStop_2*vPoint,Digits);
								
				sLog_TrailOrder = sLog_TrailOrder + sNL + "    new sl=" + DoubleToStr(sl,Digits);
				
				ticket = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Red);
				
				if (ticket > 0){
					Print ("Trailing #2 Activated: ", OrderSymbol(), ": SL ",sl, ": Ask ", Ask);
					sLog_TrailOrder = sLog_TrailOrder + sNL + "    ticket " + ticket + " modified. New StopLoss=" + DoubleToStr(sl,Digits);
					
					}
					else{
					iLastError = GetLastError();
					
					sLog_TrailOrder = sLog_TrailOrder + sNL +  "    Error modifying stop loss. Error code=" + ErrorDescription(iLastError);
					//return(0);
					}
				}
			}


}//end for(cnt=OrdersTotal();cnt>=0;cnt--){
//end if(OrdersTotal()>0){
////// if if(OrderSymbol() == Symbol() && OrderMagicNumber() ==  MagicNumber)
}//if OrderSelect()
sLog_TrailOrder = sLog_TrailOrder + sNL + "    End - TrailOrder function--------------------";

return(0);
}//end void TrailOrder(double Trailingstart,double Trailingstop){

//========================================================================================

bool closeBuyOrder(int iBuytype)
{
bool bClosed_;

if(OrdersTotal()>0)
{
for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
{
OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES);

if(iBuytype==OP_BUY && OrderType()==OP_BUY)
{
if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
 {
RefreshRates();

OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits), Slippage);

}
}
}
}

return(bClosed_);
}//end bool closeBuyOrder(int iBuytype)

//===========================================================================================

bool closeSellOrder(int iSelltype)
{
bool bClosed_;

	if(OrdersTotal()>0)
	{
		for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
		{
			if(!OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES)) continue;

			if(iSelltype==OP_SELL && OrderType()==OP_SELL)
			{
				if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
				{
					RefreshRates(); 
					bClosed_ = OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage);
				}//end if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
			}//end if(iSelltype==OP_SELL && OrderType()==OP_SELL)
		}//end for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
	}//end if(OrdersTotal()>0)
	
	
	return(bClosed_);
}//end bool closeSellOrder(int Selltype)